# -*- coding: utf-8 -*-
"""
Created on Fri Aug  5 14:05:41 2022

@author: Petr Tomasek
"""

# Solver for FDE Backward Euler method
# y'(x)=f(x,y(x)),  y(xinit)=yinit

#import fnGraphs as fnG
import numpy as np
import math
import fnNumMethCaputoFDE as FnEM
import matplotlib
 
#matplotlib.use('Agg') # musi byt pred importem pyplot
matplotlib.use('PDF') # musi byt pred importem pyplot
 
import matplotlib.pyplot as graph
from matplotlib.font_manager import FontProperties


font = FontProperties()
font.set_style('italic')
font.size=20

# INPUT
def f(t,y): #RHS of ODE
#    return(pow(t,2));
    return(-y);

alpha=0.95; #fractional derivative order     
tinit=0;
yinit=1;
tfinal=10;
h=2 #stepsize


# Inicialization of variables
IC=[tinit,yinit]
t=np.arange(IC[0],tfinal+h,h) # Mesh initialization
FE_y=np.zeros((2,len(t)));


# Computing process and graphical output
graph.figure(figsize=(10,6), dpi=120)
matplotlib.rcParams['font.size']=20
graph.grid(True)
#graph.title("Solution to FDE IVP",fontsize=20)
graph.xlabel("t",fontproperties=font)
graph.ylabel("y",rotation=0, labelpad=15,fontproperties=font)
pr=["k-o","k-.s","g--s","k-.p","r-o"]
FE_y[0]=FnEM.fnFrwEulMethod(f,alpha,tinit,yinit,tfinal,IC,h)
FE_y[1]=FnEM.fnBkwEulMethod(f,alpha,tinit,yinit,tfinal,IC,h)
#s="Ex01"+".pdf"
   
   
#graph.savefig(s, dpi=120);
graph.figure(figsize=(10,6), dpi=120)
matplotlib.rcParams['font.size']=20
graph.grid(True)
#graph.title("Solution to FDE IVP",fontsize=20)
graph.xlabel("t",fontproperties=font)
graph.ylabel("y",rotation=0, labelpad=15,fontproperties=font)
graph.plot(t, FE_y[0,:], pr[0],label = r"FFEM")
graph.plot(t, FE_y[1,:], pr[1],label = r"FBEM")
#graph.plot(t, FE_y[4,:], pr[4],label = r"$\theta =1$")
graph.legend(loc = 1)
graph.show()
graph.savefig("Ex1plot.pdf", dpi=120);   
   
 